import es, cPickle, os.path, urllib, time

### Start Config ###
log_words_on_web = 1 # Whether or not the stats are recorded on the web
### End Config###

words = {}
changes = {}
announced = False

info = es.AddonInfo()
info['name']          = "WordStats"
info['version']   = "1.3"
info['author']    = "Bonbon AKA: Bonbon367"
info['url']               = "http://addons.eventscripts.com/addons/view/wordstats"
info['description'] = "Logs every word said"

es.ServerVar('wstats_version', info['version'], 'WordStats made by Bonbon AKA Bonbon367').makepublic()


def load():
	word_db = es.getAddonPath('wordstats') + '/words.db'
	if os.path.isfile(word_db):
		global words
		word_stats = open(word_db)
		words = cPickle.load(word_stats)
		word_stats.close()
	if not es.exists('saycommand', '!wordstats'):
		es.regsaycmd('!wordstats', 'wordstats/wordstats', '!wordstats <word>')
	# Announces the server to the website (for server stats).
	if log_words_on_web:
	try:
		params = urllib.urlencode({'port':str(es.ServerVar('hostport')),'name':str(es.ServerVar('hostname')),'version':str(info.version),'game':getGame()})
		u = urllib.urlopen('http://wordstats.ojii.ch/servers_submit.php', params)
		if u.read() == 'ok':
		global announced
		announced = True
	except:
		pass

def unload():
	save_stuff()

def player_say(ev):
	global words, changes
	wts = str(ev['text']).lower()
	for x in ['!', '"', '#', '$', '%', '&', '(', ')', '*', '+', ',', '-', '.', '/', ':', ';', '<', '=', '>', '?', '@', '[', '\\', ']', '^', '_', '`', '{', '|', '}', '~']:
		wts = wts.replace(x, '')
	for a in wts.split(' '):
		if words.has_key(a.lower()): words[a.lower()] += 1
		else: words[a.lower()] = 1
		if changes.has_key(a.lower()): changes[a.lower()] += 1
		else: changes[a.lower()] = 1

def wordstats():
	global words
	if words.has_key(es.getargs().split(' ')[0].lower()):
		es.tell(es.getcmduserid(), '#multi', '#green[#lightgreenWordStats#green]: #lightgreen%s#green has been said #lightgreen%s#green times'%(es.getargs().split(' ')[0], words[es.getargs().split(' ')[0].lower()] + 1))
	else:
		es.tell(es.getcmduserid(), '#multi', '#green[#lightgreenWordStats#green]: #lightgreen%s#green has been said #lightgreen1 #greentime'%es.getargs().split(' ')[0])
		words[es.getargs().split(' ')[0].lower()] = 0
	words[es.getargs().split(' ')[0].lower()] += 1

def save_stuff():
	current_time = time.time()
	word_db = open(es.getAddonPath('wordstats') + '/words.db', 'w')
	cPickle.dump(words, word_db)
	word_db.close()
	a = open(es.getAddonPath('wordstats') + '/times.txt', 'a')
	a.write('%s - Time to save %s keys %s\n'%(time.asctime(), len(words), time.time() - current_time))
	a.close()

def round_end(ev):
	save_stuff()
	   
def es_map_start(ev):
	if log_words_on_web:
		try:
			global changes
		x = 0
			for word in changes:
				params = urllib.urlencode({'w':word,'n':changes[word]})
		x += changes[word]
				urllib.urlopen('http://wordstats.ojii.ch/submit.php', params)
		if x != 0:
		if not announced:
			params = urllib.urlencode({'port':str(es.ServerVar('hostport')),'name':str(es.ServerVar('hostname')),'version':str(info.version),'game':getGame()})
			u = urllib.urlopen('http://wordstats.ojii.ch/servers_submit.php', params)
			if u.read() == 'ok':
			global announced
			announced = True
		if announced:
				params = urllib.urlencode({'port':str(es.ServerVar('hostport')),'new':str(x)})
				urllib.urlopen('http://wordstats.ojii.ch/servers_submit.php', params)
			changes = {}
		except: pass
	   
def server_cvar(ev):
	if ev['cvarname'] == 'hostname' and log_words_on_web:
	try:
		params = urllib.urlencode({'port':str(es.ServerVar('hostport')),'name':ev['cvarvalue']})
		urllib.urlopen('http://wordstats.ojii.ch/servers_submit.php', params)
	except:
		pass
	   
def getGame():
	if str(es.ServerVar('eventscripts_currentmap')):
	cel = es.createentitylist()
	for key in cel:
		if cel[key]['classname'].endswith('gamerules'):
		return cel[key]['classname'].split('_')[0]
	else:
	gp = str(es.ServerVar('eventscripts_gamedir'))
	if gp.endswith('cstrike'):
		return 'cs'
	if gp.endswith('dod'):
		return 'dod'
	if gp.endswith('tf'):
		return 'tf'
	if gp.endswith('hl2mp'):
		return 'hl2mp'
	if gp.endswith('pvkii'):
		return 'pvkii'
	return 'unknown'
